//Code written by RishabhL
// Email rishabh.p.lavhale@gmail.compare
//
String url;
#include <SPI.h>
#include <Wire.h>
#include <ArduinoJson.h>
#include <ESP8266WiFi.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(128, 64, &Wire, OLED_RESET);

const char* ssid     = "ssid";
const char* password = "pssword";
const char* host = "ip_address";

char *myStrings[] = {"Mumbai","Pune", "Nagpur", "Amravati"}; // Name of cities

void setup() {
   Wire.begin(2, 0);   
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);

  display.clearDisplay();

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  // Display static text
 
  Serial.begin(115200);
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  //
    display.setCursor(0, 10);
    display.println("Connecting to ");
    display.setCursor(0, 20); 
    display.println(ssid);
    display.display(); 
    
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
    display.setCursor(0, 30);
    display.println("IP address:");
    display.setCursor(0,40); 
    display.println(WiFi.localIP());
    display.display(); 
}



void loop() {

//for(int i=0;i<4  <----No. of cities you are going to fetch
for(int i=0;i<4;i++)
{
  delay(1000);

  Serial.print("connecting to ");
  Serial.println(host);

  WiFiClient client;
  const int httpPort = 80;
  
  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }

String url="http://ip_address/Covid/covid.php";


  Serial.print("Requesting URL: ");
  Serial.println(url);

  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");
  delay(2000);

  // Read all the lines of the reply from server and print them to Serial
  Serial.println("Respond:");
  while(client.available()){
    String line = client.readString();
	
	// substring(213) ===> 213th position from where json string starts i.e. 1st {
	//Serial.print(line); // analyse your response by uncommenting
	//	this to find start of json string
	Serial.print(line.substring(213));
	const size_t capacity = JSON_OBJECT_SIZE(3) + JSON_ARRAY_SIZE(2) + 60;
    DynamicJsonBuffer jsonBuffer(capacity);

    // Parse JSON object
    JsonObject& root = jsonBuffer.parseObject(line.substring(213));
    if (!root.success()) {
      Serial.println(F("Parsing failed!"));
      return;
    }

    
     
    // Display on Display
      display.clearDisplay();
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0,0);
      display.println("Cov-19 Update");
      display.setTextSize(2);
      display.setCursor(0,10);
      display.println(myStrings[i]);
      display.setTextSize(1);
      display.setCursor(0,30); 
      display.println("Confirmed:");
      display.setCursor(70,30); 
      display.println(root[myStrings[i]]["confirmed"].as<char*>());
      display.setCursor(0,40); 
      display.println("Death:");
      display.setCursor(70,40); 
      display.println(root[myStrings[i]]["death"].as<char*>()); 
      
      display.setCursor(0,50);
      display.println("Recovered:");
      display.setCursor(70,50); 
      display.println(root[myStrings[i]]["recovered"].as<char*>());
      
      display.display(); 
      
    // Decode JSON/Extract values
    Serial.println(F("Response:"));
    Serial.println(root[myStrings[i]]["confirmed"].as<char*>());
    Serial.println(root[myStrings[i]]["death"].as<char*>());
    Serial.println(root[myStrings[i]]["recovered"].as<char*>());
    jsonBuffer.clear();
  
  }
  Serial.println();
  Serial.println("closing connection");

}

}